/*
Aug. 13/97. This is a card game I wrote along time ago. I don't think
Clipper is really intended for game programming, but I thought I would see
what I could do. It's not documented and as I recall there are a few bugs.
Anyway, it's public domain. Do as you like with it.
If you fix it up, it would be nice of you to send me a copy.

Regards, TestedOK@aol.com
*/


#command  CLS           => setcolor("bg+/"+cbackgroundcolor); __Clear();banner()
#command  CLRSCR           =>  __Clear()

#include "inkey.ch"

static adeck
static ncardval := 1
static ccardname := 2
static spade := chr(6)
static heart := chr(3)
static club := chr(5)
static diamond := chr(4)
static cstatuscolor
static cbackgroundcolor := "RB+"  //r+ b+ G+
static cardmatcolor 
static cmessagecolor := "g/n"
static cinputcolor := "gr+/n,gr+/n"
static cdealcolor := "bg+/n"
static ndecksize := 52
static ndelay := 2
static nhousemax := 500
static ncardsleft := 0
static ndeckpos := 1
static anewdeck
function cardmenu()
  local nchoice := 1
  local ntop:=11,nleft:=13
  //local ntop:=0,nleft:=0
  local cmenuscr
  local coldcolor
  local cmenucolor

  cmessagecolor := "bg+*/"+cbackgroundcolor
  cinputcolor := "gr+/"+cbackgroundcolor+",gr+/" +cbackgroundcolor
  cdealcolor := "bg+/"+cbackgroundcolor
  cstatuscolor := "bg+/"+cbackgroundcolor
  cardmatcolor := "w/"+cbackgroundcolor
  cmenucolor := "bg+/"+cbackgroundcolor+",gr+/r"
  //cmenucolor := "bg+/"+"r"+",b/gr+"

  setcolor(cdealcolor)
  set wrap on
  newdeck()
  shuffle()
  mat()
  setkey(K_F1,{||HELPcards()})
  @ntop,nleft clear to ntop+6,nleft + 13
  @ntop,nleft to ntop+6,nleft + 13 double
  boxshadow(ntop,nleft,ntop+6,nleft + 13)
  ntop++
  
  do while .t.
    setcolor(cmenucolor)
    ntop := 12
    @ntop,nleft+1 prompt "5 CARD POKER"
    ntop++
    @ntop,nleft+1 prompt "7 CARD POKER"
    ntop++
    @ntop,nleft+1 prompt "BLACKJACK"
    ntop++
    @ntop,nleft+1 prompt "BETWEEN"
    ntop++
    @ntop,nleft+1 prompt "QUIT"
    ntop++
    cmenuscr := savescreen(0,0,maxrow(),maxcol())
    menu to nchoice
    do case
      case nchoice = 1
        playpoker(5)
      case nchoice = 2
        playpoker(7)
      case nchoice = 3
        play21()
      case nchoice = 4
        playbetween()
      case nchoice = 5
        setmode(25,80)
        clrscr
        return nil
      otherwise
        loop
    endcase
    setkey(K_F1,{||HELPcards()})
    set confirm on
    setcolor(cmenucolor)
    setmode(25,40)
    restscreen(0,0,maxrow(),maxcol(),cmenuscr)
  enddo
  return nil

static function random(nseed)
 local aray := {77111.35,787919.17,89717.99,77555.11,52212.55,36636.09,;
                63838.18,35283.67,49784.67,66325.33,;
                61288.87,93117.25,11259.56,83197.45,53513.89,79918.56}
 local nretval := 0
 local nlen
 local ctemp := ""
 local npos := 0
 static nstep := 1
 if nseed = nil .or. nseed = 0
   return nseed := int(seconds())
 endif
 while .t.
   nstep ++
   if nstep > len(aray)
     nstep := 1
   endif
   nretval := nseed*aray[nstep]/seconds()*int(seconds())
   ctemp := str(nretval)
   npos := at(".",ctemp)
   nlen := len(alltrim(str(nseed)))
   if npos > 0
     ctemp := substr(ctemp,1,npos-1)+substr(ctemp,npos+1,len(ctemp))
   endif
   ctemp := right(ctemp,nlen)
   nretval := val(ctemp)
   if nretval <= nseed
     exit
   endif
 enddo
return nretval




static FUNCTION center(cstr) //center a string 
  local n
  n:=len(cstr)/2
  @row(),maxcol()/2-n say cstr
  return ""


  
static FUNCTION BoxShadow( nTop, nLeft, nBottom, nRight )
   LOCAL nShadTop, nShadLeft, nShadBottom, nShadRight
   if col() > maxcol()-5
     return nil
   endif
   nShadTop   := nShadBottom := MIN(nBottom + 1, MAXROW())
   nShadLeft  := nLeft + 1
   nShadRight := MIN(nRight + 1, MAXCOL())

   RESTSCREEN( nShadTop, nShadLeft, nShadBottom, nShadRight,;
       TRANSFORM( SAVESCREEN(nShadTop, nShadLeft, nShadBottom, nShadRight),;
       REPLICATE("X", nShadRight - nShadLeft + 1 ) ) )

   nShadTop    := nTop + 1
   nShadLeft   := nShadRight := MIN(nRight + 1, MAXCOL())
   nShadBottom := nBottom

   RESTSCREEN( nShadTop, nShadLeft, nShadBottom, nShadRight,;
       TRANSFORM( SAVESCREEN(nShadTop,  nShadLeft , nShadBottom,  nShadRight),;
       REPLICATE("X", nShadBottom - nShadTop + 1 ) ) )
   
   RETURN NIL


static function message(cmess,ccolor)  
  local coldcolor := setcolor(cmessagecolor)
  local noldcol := col()
  local noldrow := row()
  if ccolor <> nil
     setcolor(ccolor)
  endif
  setpos(maxrow(),0)
  center(cmess)
  setcolor(coldcolor)
  setpos(noldrow,noldcol)
  return nil

static function clrmessage()
  local coldcolor := setcolor(cstatuscolor)
  @maxrow(),0 clear to maxrow(),maxcol()
  setcolor(coldcolor)
  return nil


static function newdeck()
  local n,nn,nctr := 1
  static atemp := {}

  if len(atemp) > 0 // build new deck only once
    adeck := aclone(atemp)
    return nil
  endif
  
  adeck := array(ndecksize,2)  // ndecksize is 52 for single deck
  /*
  for nn := 3 to 6  // add ace's
      adeck[nctr,1]:=14
      adeck[nctr,2] := "A" + chr(nn)
      nctr++
  next
  */
  for n := 2 to 10 // regular cards
    for nn := 3 to 6  // add the suits
      adeck[nctr,1]:=n
      adeck[nctr,2] := alltrim(str(n)) + chr(nn)
      nctr++
    next
  next
  for nn := 3 to 6  // add jack's
    adeck[nctr,1]:=11
    adeck[nctr,2] := "J" + chr(nn)
    nctr++
  next
  for nn := 3 to 6  // add queen's
    adeck[nctr,1]:=12
    adeck[nctr,2] := "Q" + chr(nn)
    nctr++
  next
  for nn := 3 to 6  // add king's
    adeck[nctr,1]:=13
    adeck[nctr,2] := "K" + chr(nn)
    nctr++
  next
  for nn := 3 to 6  // add ace's
      adeck[nctr,1]:=14
      adeck[nctr,2] := "A" + chr(nn)
      nctr++
  next

  atemp := aclone(adeck)
  anewdeck := aclone(adeck)
return nil


static function shuffle()
  local n,ncard
  local atemp := array(52,2)
  
  for n := 1 to 12
    do while .t.
      ncard := random(52)
      if ncard = 0
        loop
      endif
      if adeck[ncard,1] <> 99
        atemp[n,1] := adeck[ncard,1]
        atemp[n,2] := adeck[ncard,2]
        adeck[ncard,1] := 99
        exit
      endif
    enddo
  next
  adeck := aclone(atemp)
return nil



static function  potvaluemess(npotval)
  local coldcolor := setcolor(cstatuscolor)
  @maxrow()-2,0 clear to maxrow()-2,maxcol()
  setpos(maxrow()-2,0)
  center("There is "+alltrim(str(npotval))+" in the pot.")
  setcolor(coldcolor)
return nil

static function anykeymessage()
  local coldcolor := setcolor(cstatuscolor)
  @maxrow()-2,0 clear to maxrow()-2,maxcol()
  setpos(maxrow()-2,0)
  center("Strike any key...")
  setcolor(coldcolor)
return nil

static function banner()
 local coldcolor := setcolor("r/w")
 @0,0 clear to 0,maxcol()
 center("C*A*S*I*N*O")
 @0,0 say "F1=help"
 setcolor(coldcolor) 
return nil


static function olddealcard(nrow,ncol,ccardname )
  local n, noldrow := nrow
  local coldcolor := setcolor("b/w")
  
  setpos(nrow,ncol)
  
  @nrow,ncol to nrow + 5 , ncol + 6
  boxshadow(nrow,ncol,nrow + 5,ncol + 6)
  for n:=1 to 4
    @nrow+1,ncol+1 say replicate(" ",5)
    nrow++
  next
  nrow := noldrow
  if right(alltrim(ccardname),1) = chr(6) .or.; // it's a club or spade
        right(alltrim(ccardname),1) = chr(5)
    setcolor("n/w")
    else
    setcolor("r/w")
  endif
  @nrow+1,ncol+1 say alltrim(ccardname)
  @nrow+4,ncol+6-len(alltrim(ccardname)) say alltrim(ccardname)
  setcolor(coldcolor)
  return nil

function HELPCARDS()
  local coldscr := savescreen(0,0,maxrow(),maxcol())
  local coldcolor := setcolor("gr+/r")
  setmode(25,80)
  clrscr
  banner()
  setpos(2,0)
  TEXT
     
     Use the arrow keys to highlite to game you wish to play and press
     the ENTER key. Help for each game is available as you play them.



     ABOUT CASINO
     Casino was written by TestedOk@aol.com.
     I love to get E-mail!

  
  
  



  
  
  
  
  
  ENDTEXT
  center("Strike any key...")
  inkey(0)
  setmode(25,40)
  setcolor(coldcolor)
  restscreen(0,0,maxrow(),maxcol(),coldscr)
  return nil

static function OLDmat()
local n,nn,nctr:=1
local npos := 1
  //alert(str(len(adeck[1])))
  for n := 1 to maxrow()
    @n,0 say replicate(chr(176),maxcol()+1)
  next
  for n := 2 to maxrow() step 8
    for nn := 3 to maxcol()-3 step 9
      dealcard(n,nn,adeck[nctr,2])
      inkey(.1)
      nctr ++
    next
  next
return nil

static function mat()
local n,nn,nctr:=1,i
local npos := 1
  setmode(25,80)
  cls
  for n := 1 to maxrow()
    @n,0 say replicate(chr(176),maxcol()+1)
  next
  // show new deck...
  for n := 2 to maxrow() step 8
    for nn := 0 to maxcol()-2 step 4  // was 4
      dealcard(n,nn,anewdeck[nctr,2])
      inkey(.01)
      nctr ++
      if nctr > 52
        exit
      endif
    next
    if nctr > 52
      exit
    endif
  next
  inkey(1)
  nctr := 1
  for n := 2 to maxrow() step 8
    for nn := 0 to maxcol()-2 step 4  // was 4
      dealcard(n,nn,"")
      inkey(.01)
      nctr ++
      if nctr > 52
        exit
      endif
    next
    if nctr > 52
      exit
    endif
  next
  inkey(2)
  //
  setmode(25,40)
  cls
  for n := 1 to maxrow()
    @n,0 say replicate(chr(176),maxcol()+1)
  next
  nctr := 1
  for n := 2 to maxrow() step 8
    for nn := 3 to maxcol()-3 step 9
      dealcard(n,nn,adeck[nctr,2])
      inkey(.2)
      nctr ++
    next
  next
return nil

static function dealcard(nrow,ncol,ccardname )
  local n, noldrow := nrow
  local coldcolor := setcolor("b/w")
  
  setpos(nrow,ncol)
  
  @nrow,ncol to nrow + 5 , ncol + 6
  boxshadow(nrow,ncol,nrow + 5,ncol + 6)
  
  if empty(ccardname) // the dealer's down card
    for n:=1 to 4
      @nrow+1,ncol+1 say replicate(chr(176),5)
      nrow++
    next
    else
    for n:=1 to 4
      @nrow+1,ncol+1 say replicate(" ",5)
      nrow++
    next
  endif
  nrow := noldrow
  if right(alltrim(ccardname),1) = chr(6) .or.; // it's a club or spade
        right(alltrim(ccardname),1) = chr(5)
    setcolor("n/w")
    else
    setcolor("r/w")
  endif
  @nrow+1,ncol+1 say alltrim(ccardname)
  @nrow+4,ncol+6-len(alltrim(ccardname)) say alltrim(ccardname)
  setcolor(coldcolor)
  return nil


